/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.thin.tutorial.service.blogic;

import java.util.HashMap;
import java.util.Map;

import jp.terasoluna.fw.dao.QueryDAO;
import jp.terasoluna.thin.tutorial.service.bean.UserBean;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * ꗗ擾rWlXWbNB
 *
 * f[^x[Xʂɕ\錏݈̂ꗗ擾B
 * ܂Aꗗ̑S擾B
 *
 */
public class ListBLogicImpl implements ListBLogic{

    /**
     * ONXB
     */
    private Log log = LogFactory.getLog(ListBLogicImpl.class);

    /**
     * DAONXB
     * SpringɂCX^Xݒ肳B
     */
    private QueryDAO dao = null;

    /**
     * QueryDAOԋpB
     *
     * @return ێQueryDAO
     */
    public QueryDAO getDao() {
        return dao;
    }

    /**
     * QueryDAOݒ肷B
     *
     * @param dao QueryDAO
     */
    public void setDao(QueryDAO dao) {
        this.dao = dao;
    }

    /**
     * f[^x[Xꗗ擾B
     * 1y[W̕\ƊJnCfbNX擾AQueryDAOɓnB
     * ܂Aꗗ̑S擾ԋpB
     *
     * @param map \AJnCfbNXێMap
     * @return ꗗASێMap
     */
    public Map<String, Object> getUserList(Map<String, String> map) {

        if (log.isDebugEnabled()) {
            log.debug("getUserList Start.");
        }

        String strIndex = map.get("startIndex");
        String strRow = map.get("row");

        int startIndex = 0;
        int row = 10;
        if (strIndex != null) {
            try {
                startIndex = Integer.parseInt(strIndex);
            } catch (NumberFormatException e) {
                startIndex = 0;
            }
        }
        if (strRow != null) {
            try {
                row = Integer.parseInt(strRow);
            } catch (NumberFormatException e) {
                row = 10;
            }
        }

        UserBean[] bean = dao.executeForObjectArray("getUserList", null,
                UserBean.class, startIndex, row);

        Map<String, Object> retMap = new HashMap<String, Object>();
        retMap.put("totalCount", getUserCount());
        retMap.put("userBeans", bean);

        return retMap;

    }

    /**
     * ꗗ̑S擾ĕԋpB
     *
     * @return 擾
     */
    public String getUserCount() {

        if (log.isDebugEnabled()) {
            log.debug("getUserList Start.");
        }

        String count
            = dao.executeForObject("getUserCount", null, String.class);
        if (count == null || "".equals(count)) {
            count = "0";
        }
        return count;
    }

}
